SystemOrganization addCategory: #KillTextConstants!

Object subclass: #KillTextConstants
	instanceVariableNames: 'oldClassesUsingTextConstants'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KillTextConstants'!

!KillTextConstants commentStamp: 'BenjaminVanRyseghem 11/10/2010 13:15' prior: 0!
TurlututuChapeauPointu!

!KillTextConstants methodsFor: 'step5' stamp: 'BenjaminVanRyseghem 11/19/2010 15:07'!
addAccessors: aDictionary

	| class string |
	class := Smalltalk at: #TextConstants.
	aDictionary keys do: [:symbol || stream |
		stream := WriteStream with: symbol asString.
		stream 
			nextPut: Character cr;
			nextPutAll: '	^';
			nextPutAll: symbol asString.
		class classSide compile: stream contents classified: 'accessing' notifying: nil].
	
	"Special case for TextSharedInformation"
	string := 'TextSharedInformation
	^TextSharedInformation'.
	class classSide compile: string classified: 'accessing' notifying: nil! !

!KillTextConstants methodsFor: 'step6' stamp: 'BenjaminVanRyseghem 11/14/2010 00:47'!
addTextConstantsAsPoolDictionary

	self classesWhichMustUseTextConstants do: [:class | class addSharedPool: (Smalltalk at: TextConstants)]! !

!KillTextConstants methodsFor: 'step6 - fix Paragraph' stamp: 'BenjaminVanRyseghem 11/14/2010 00:56'!
caretFormForDepthSource
	^'caretFormForDepth: depth
	"Return a caret form for the given depth."
	"(Paragraph new caretFormForDepth: Display depth) displayOn: Display at: 0@0 rule: Form reverse"

	| box f bb map CaretForm |
	CaretForm := ', self textConstantsCopySymbol asString, ' at: #CaretForm.
	box := CaretForm boundingBox.
	f := Form extent: box extent depth: depth.
	map := (Color cachedColormapFrom: CaretForm depth to: depth) copy.
	map at: 1 put: (Color transparent pixelValueForDepth: depth).
	map at: 2 put: (Color quickHighLight: depth) first.  "pixel value for reversing"
	bb := BitBlt current toForm: f.
	bb
		sourceForm: CaretForm;
		sourceRect: box;
		destOrigin: 0@0;
		colorMap: map;
 		combinationRule: Form over;
		copyBits.
	^ f'! !

!KillTextConstants methodsFor: 'step6' stamp: 'Bvr 11/24/2010 21:49'!
change: old by: new in: class

	| definition index size  before after |
	definition := class definition.
	index := definition findString: 'poolDictionaries'.
	size := old size.
	index := definition findString: old startingAt: index.
	index == 0 ifTrue:[^nil].

	before := definition copyFrom: 1 to: (index - 1).
	after := definition copyFrom: index+size to: (definition size).
	definition := new join: {before.after}.
	
	Compiler evaluate: definition.! !

!KillTextConstants methodsFor: 'step5' stamp: 'BenjaminVanRyseghem 11/10/2010 17:18'!
classTemplate
	^'SharedPool subclass: #TextConstants
instanceVariableNames: ''''
classVariableNames: ''''
poolDictionaries: ''''
category: ''Collections-Text'''! !

!KillTextConstants methodsFor: 'step6' stamp: 'BenjaminVanRyseghem 11/14/2010 00:44'!
classesWhichMustUseTextConstants

	^(self methodsInvokingTextConstants collect: [:each | Smalltalk at: each classSymbol]) asSet! !

!KillTextConstants methodsFor: 'step3' stamp: 'Bvr 11/26/2010 18:54'!
collectOldClasses: aCollection

	| classesAndMetaClasses classes classesUsingTextConstants |

	classesUsingTextConstants := Smalltalk allClasses select: [:class | self theClassUsesTextConstants: class].
	
	classesAndMetaClasses := aCollection collect:[:each | each actualClass].
	classesAndMetaClasses := classesAndMetaClasses addAll: classesUsingTextConstants;yourself.
	classes := classesAndMetaClasses collect: [:each | 
					each isMeta
						ifTrue: [each soleInstance]
						ifFalse:[each]].
					
	oldClassesUsingTextConstants := classes asSet! !

!KillTextConstants methodsFor: 'step5' stamp: 'Bvr 11/10/2010 22:40'!
crappyOldInitialize
	 
	"Initialize constants shared by classes associated with text display, e.g., 
	Space, Tab, Cr, Bs, ESC."
		"1/24/96 sw: in exasperation and confusion, changed cmd-g mapping from 231 to 232 to see if I could gain any relief?!!"


	| letter varAndValue tempArray width DefaultTab dictionary |
	
	dictionary := Dictionary new.
	
	"CtrlA..CtrlZ, Ctrla..Ctrlz"
	letter := $A.
 	#(		212 230 228 196 194 226 241 243 214 229 200 217 246 
			245 216 202 210 239 211 240 197 198 209 215 242 231
	 		1 166 228 132 130 12 232 179 150 165 136 153 182 
			14 15 138 17 18 19 11 21 134 145 151 178 167 ) do:
		[:kbd |
		dictionary at: ('Ctrl', letter asSymbol) asSymbol put: kbd asCharacter.
		letter := letter == $Z ifTrue: [$a] ifFalse: [(letter asciiValue + 1) asCharacter]].

	varAndValue := #(
		Space	32
		Tab		9
		CR		13
		Enter	3
		BS		8
		BS2		158
		ESC		160
		Clear 	173
	).

	varAndValue size odd ifTrue: [self error: 'unpaired text constant'].
	(2 to: varAndValue size by: 2) do:
		[:i | dictionary at: (varAndValue at: i - 1) put: (varAndValue at: i) asCharacter].

	varAndValue := #(
		CtrlDigits 			(159 144 143 128 127 129 131 180 149 135)
		CtrlOpenBrackets	(201 7 218 249 219 15)
			"lparen gottn by ctrl-:= = 201; should be 213 but can't type that on Mac"

			"location of non-character stop conditions"
		EndOfRun	257
		CrossedX	258

			"values for alignment"
		LeftFlush	0
		RightFlush	1
		Centered	2
		Justified	3

			"subscripts for a marginTabsArray tuple"
		LeftMarginTab	1
		RightMarginTab	2

			"font faces"
		Basal	0
		Bold	1
		Italic	2

			"in case font doesn't have a width for space character"
			"some plausible numbers-- are they the right ones?"
		DefaultSpace			4
		DefaultTab				24
		DefaultLineGrid			16
		DefaultBaseline			12
		DefaultFontFamilySize	3	"basal, bold, italic"
	).

	varAndValue size odd ifTrue: [self error: 'unpaired text constant'].
	(2 to: varAndValue size by: 2) do:
		[:i | dictionary at: (varAndValue at: i - 1) put: (varAndValue at: i)].

	DefaultTab := dictionary at: #DefaultTab.

	dictionary at: #DefaultRule	put: Form over.
	dictionary at: #DefaultMask	put: Color black.

	width := Display width max: 720.
	tempArray := Array new: width // DefaultTab.
	1 to: tempArray size do:
		[:i | tempArray at: i put: DefaultTab * i].
	dictionary at: #DefaultTabsArray put: tempArray.
	tempArray := Array new: (width // DefaultTab) // 2.
	1 to: tempArray size do:
		[:i | tempArray at: i put: (Array with: (DefaultTab*i) with: (DefaultTab*i))].
	dictionary at: #DefaultMarginTabsArray put: tempArray.

"Text initTextConstantsCopy "
	^dictionary! !

!KillTextConstants methodsFor: 'step5' stamp: 'BenjaminVanRyseghem 11/28/2010 15:00'!
createInitialize: dictionary
	"create the initialize method for TextConstants class"
	| stream |

     stream := WriteStream with: 'initialize'.
	stream
		nextPutAll: String cr;
		nextPutAll: String cr;
		nextPutAll: '	';
		nextPutAll: self textConstantsCopySymbol asString;
		nextPutAll: ' ifNil: [ ';
		nextPutAll:  self textConstantsCopySymbol asString;
		nextPutAll: ' := Dictionary new].'.
		
	dictionary associations do: [:association || value |
		value := association value.
		stream 
			nextPutAll: String cr;
			nextPutAll: '	';
			nextPutAll: association key asString;
			nextPutAll: ' := '.
		value isCharacter
			ifTrue: [stream 
						nextPutAll: 'Character value: ';
						nextPutAll: value asciiValue asString.]
			ifFalse:[stream nextPutAll: value printString].
		stream
			nextPutAll: '.'].
		
	^stream! !

!KillTextConstants methodsFor: 'step6 - fix TextStyle' stamp: 'BenjaminVanRyseghem 11/14/2010 00:58'!
defaultFamilyNamesSource
	^'defaultFamilyNames
	| DefaultTextStyle DefaultFixedTextStyle DefaultMultiStyle |

	DefaultTextStyle := ', self textConstantsCopySymbol asString, ' at: #DefaultTextStyle.
	DefaultFixedTextStyle := ', self textConstantsCopySymbol asString, ' at: #DefaultFixedTextStyle.
	DefaultMultiStyle := ', self textConstantsCopySymbol asString, ' at: #DefaultMultiStyle.
	
	^#(DefaultTextStyle DefaultFixedTextStyle DefaultMultiStyle)'! !

!KillTextConstants methodsFor: 'step6 - fix TextStyle' stamp: 'BenjaminVanRyseghem 11/12/2010 16:19'!
defaultFontSource
	^'defaultFont
	"Answer the default system font"

	^ self default defaultFont'! !

!KillTextConstants methodsFor: 'step6 - fix TextStyle' stamp: 'BenjaminVanRyseghem 11/14/2010 00:58'!
defaultSource
	^'default
	"Answer the system default text style."

	^', self textConstantsCopySymbol asString, ' at:# DefaultTextStyle'! !

!KillTextConstants methodsFor: 'step6 - fix DisplayText' stamp: 'Bvr 11/25/2010 14:25'!
fixDisplayText

	DisplayText classSide 
		compile: self textSource.
	oldClassesUsingTextConstants add: DisplayText.! !

!KillTextConstants methodsFor: 'step6 - fix Paragraph' stamp: 'Bvr 11/25/2010 14:25'!
fixParagraph
	Paragraph compile: self caretFormForDepthSource.
	Paragraph classSide compile: self withTextSource.
	oldClassesUsingTextConstants add: Paragraph.! !

!KillTextConstants methodsFor: 'step6 - fix TextStyle' stamp: 'Bvr 11/25/2010 14:25'!
fixTextStyle
	TextStyle classSide 
		compile: self defaultSource;
		compile: self setDefaultSource;
		compile: self defaultFamilyNamesSource;
		compile: self defaultFontSource.
	oldClassesUsingTextConstants add: TextStyle! !

!KillTextConstants methodsFor: 'step5' stamp: 'Bvr 11/28/2010 15:15'!
initializeTextConstants: aDictionary

	| stream class |
	
	class := Smalltalk at: #TextConstants.
	class addClassVarNamed: self textConstantsCopySymbol asString.
	
	aDictionary keys do: [:symbol | class addClassVarNamed: symbol asString].
	
	stream := self createInitialize: aDictionary.
	
	class classSide compile: stream contents classified: 'initialization' notifying: nil.
	class classSide compile: self initializeTextSharedInformationSource classified: 'initialization' notifying: nil.
	class initialize.
	class initializeTextSharedInformation.
	class classSide removeSelector: #initializeTextSharedInformation.! !

!KillTextConstants methodsFor: 'step5' stamp: 'BenjaminVanRyseghem 11/28/2010 15:12'!
initializeTextSharedInformationSource
	^ 'initializeTextSharedInformation
	"should be removed asap"

	TextSharedInformation := Smalltalk at: #TextSharedInformation.'! !

!KillTextConstants methodsFor: 'step2' stamp: 'Bvr 11/26/2010 19:23'!
methodsInvokingTextConstants
	"I do not check methods invoking #TextConstants because the only real method invoking it (except mine) also invokes TextConstants"

	| all |
	all := SystemNavigation default allReferencesTo: (Smalltalk globals associationAt: #TextConstants).
	all removeAll: (all select: [:each | each classSymbol == #KillTextConstants]).
	self collectOldClasses: all.
	^all! !

!KillTextConstants methodsFor: 'step8' stamp: 'BenjaminVanRyseghem 11/19/2010 16:16'!
objectForDataStreamSource
	^'objectForDataStream: refStrm
	| dp |
	"I am about to be written on an object file.  If I am one of two shared global arrays, write a proxy instead."

self == ((Smalltalk at:#TextConstants) DefaultTabsArray) ifTrue: [
	dp := DiskProxy global: #TextConstants selector: #DefaultTabsArray args: {}.
	refStrm replace: self with: dp.
	^ dp].
self == ((Smalltalk at:#TextConstants) DefaultMarginTabsArray) ifTrue: [
	dp := DiskProxy global: #TextConstants selector: #DefaultMarginTabsArray args: {}.
	refStrm replace: self with: dp.
	^ dp].
^ super objectForDataStream: refStrm'! !

!KillTextConstants methodsFor: 'step8' stamp: 'BenjaminVanRyseghem 11/19/2010 15:50'!
printSingleCommentSource
	^'printSingleComment: aString on: aStream indent: indent 
	"Print the comment string, assuming it has been indented indent tabs.
	Break the string at word breaks, given the widths in the default
	font, at 450 points."

	| readStream word position lineBreak font wordWidth tabWidth spaceWidth lastChar |
	readStream := aString readStream.
	font := TextStyle default defaultFont.
	tabWidth := DefaultTab.
	spaceWidth := font widthOf: Character space.
	position := indent * tabWidth.
	lineBreak := 450.
	[readStream atEnd]
		whileFalse: 
			[word := self nextWordFrom: readStream setCharacter: [:lc | lastChar := lc].
			wordWidth := word inject: 0 into: [:width :char | width + (font widthOf: char)].
			position := position + wordWidth.
			position > lineBreak
				ifTrue: 
					[aStream skip: -1; crtab: indent.
					position := indent * tabWidth + wordWidth + spaceWidth.
					lastChar = Character cr
						ifTrue: [[readStream peekFor: Character tab] whileTrue].
					word isEmpty ifFalse: [aStream nextPutAll: word; space]]
				ifFalse: 
					[aStream nextPutAll: word.
					readStream atEnd
						ifFalse: 
							[position := position + spaceWidth.
							aStream space].
					lastChar = Character cr
						ifTrue: 
							[aStream skip: -1; crtab: indent.
							position := indent * tabWidth.
							[readStream peekFor: Character tab] whileTrue]]]'! !

!KillTextConstants methodsFor: 'step6' stamp: 'Bvr 11/25/2010 12:44'!
reAddPoolDictionaries

	oldClassesUsingTextConstants doWithIndex: [:class :index | 
		(self change: 'private' by: 'TextConstants' in: class)
			ifNil:[class addSharedPool: (Smalltalk at: #TextConstants)]]! !

!KillTextConstants methodsFor: 'step2' stamp: 'BenjaminVanRyseghem 11/13/2010 16:51'!
removeTextInitTextConstants

	Text classSide removeSelector: #initTextConstants.! !

!KillTextConstants methodsFor: 'entry point' stamp: 'BenjaminVanRyseghem 11/28/2010 15:28'!
script

	| fullName |
	fullName := Author fullNamePerSe.
	Author fullName: 'Benjamin Van Ryseghem'.
	
	"copy the global variable as SharedDictionary"
	self step1CopyGlobalVar.
	
	"redirect all methods -- import ChangeSorter"
	self step2RedirectAllReferences.
	
	"collect all classes which used TextConstants as a poolDictionary"
	"self step3CollectClassesUsingTextConstants." "done in step2"
	
	"remove the Smalltalk globals association"
	self step4RemoveGlobalAssociation.
	
	"create a real pretty smooth class inheriting from SharedPool"
	self step5CreateTextConstantsAsSharedPool.
	
	"change poolDictionaries"
	self step6ReAddPoolDictionaries.
	
	"remove the copy from Smalltalk globals"
	self step7RemoveTheCopyFromSmalltalk.
	
	"fix two methods"
	self step8RecompileTheTwoMethodsNeeded.
	
	"remove SharedDictionary entries which refer to TextConstants classVar"
	self step9RemoveEntriesTextSharedInformation.
	
	Author fullName: fullName.! !

!KillTextConstants methodsFor: 'step6 - fix TextStyle' stamp: 'BenjaminVanRyseghem 11/14/2010 00:58'!
setDefaultSource
	^'setDefault: aTextStyle
	"Answer the system default text style."

	', self textConstantsCopySymbol asString, ' at: #DefaultTextStyle put: aTextStyle.'! !

!KillTextConstants methodsFor: 'step1' stamp: 'Bvr 11/11/2010 22:04'!
step1CopyGlobalVar
	| copy |
	copy := (Smalltalk at: #TextConstants) copy.
	Smalltalk at: self textConstantsCopySymbol put: copy! !

!KillTextConstants methodsFor: 'step2' stamp: 'BenjaminVanRyseghem 11/13/2010 16:52'!
step2RedirectAllReferences

	| size |
	size := 'TextConstants' size.
	
	self removeTextInitTextConstants.

	self methodsInvokingTextConstants do: [:method || source index|
		source := method sourceCode.
		index := method sourceCode indexOf: Character cr..
		[(index :=  (source findString: 'TextConstants' startingAt: index)) > 0]
		whileTrue:[
			| before after suffix |
			before := source copyFrom: 1 to: (index-1).
			after := source copyFrom: index+size to: (source size).
			suffix := self textConstantsCopySymbol asString.
			source := suffix join: {before.after}.
			index := index + size + 1].
		method actualClass compile: source].! !

!KillTextConstants methodsFor: 'step3' stamp: 'Bvr 11/24/2010 22:06'!
step3CollectClassesUsingTextConstants

	| list classesAndMetaclasses classes |
	list := (SystemNavigation default allMethodsWithSourceString: 'TextConstants' matchCase: true).
	classesAndMetaclasses := list collect: [:each | each methodClass].
	classes := classesAndMetaclasses collect: [:each | 
					each isMeta
						ifTrue: [each soleInstance]
						ifFalse:[each]].
	
	oldClassesUsingTextConstants :=  classes asSet copyWithout: self class! !

!KillTextConstants methodsFor: 'step4' stamp: 'BenjaminVanRyseghem 11/12/2010 13:59'!
step4RemoveGlobalAssociation

	Smalltalk globals removeKey: #TextConstants! !

!KillTextConstants methodsFor: 'step5' stamp: 'BenjaminVanRyseghem 11/28/2010 15:04'!
step5CreateTextConstantsAsSharedPool
	
	| dictionary |
	Smalltalk globals removeKey: #TextConstants ifAbsent:[]. 
	SharedPool subclassDefinerClass evaluate: self classTemplate.
	
	dictionary := self crappyOldInitialize.
	self initializeTextConstants: dictionary.
	self addAccessors: dictionary.! !

!KillTextConstants methodsFor: 'step6' stamp: 'Bvr 11/25/2010 14:25'!
step6ReAddPoolDictionaries
	self fixTextStyle.
	self fixDisplayText.
	self fixParagraph.
	self reAddPoolDictionaries.
	self addTextConstantsAsPoolDictionary.! !

!KillTextConstants methodsFor: 'step7' stamp: 'BenjaminVanRyseghem 11/14/2010 00:48'!
step7RemoveTheCopyFromSmalltalk

	Smalltalk globals removeKey: self textConstantsCopySymbol! !

!KillTextConstants methodsFor: 'step8' stamp: 'BenjaminVanRyseghem 11/19/2010 15:51'!
step8RecompileTheTwoMethodsNeeded
	Array compile: self objectForDataStreamSource.
	ParseNode compile: self printSingleCommentSource! !

!KillTextConstants methodsFor: 'step9' stamp: 'BenjaminVanRyseghem 11/19/2010 16:11'!
step9RemoveEntriesTextSharedInformation
	
	| dictionary |
	dictionary := self crappyOldInitialize.
	dictionary keys do:[:key |
		((Smalltalk at:#TextConstants) TextSharedInformation) removeKey: key]! !

!KillTextConstants methodsFor: 'step1' stamp: 'BenjaminVanRyseghem 11/15/2010 13:55'!
textConstantsCopySymbol

	^#TextSharedInformation! !

!KillTextConstants methodsFor: 'step6 - fix DisplayText' stamp: 'BenjaminVanRyseghem 11/14/2010 01:04'!
textSource
	^'text: aText 
	"Answer an instance of me such that the text displayed is aText 
	according to the system''s default text style."

	^self new
		setText: aText
		textStyle: (', self textConstantsCopySymbol asString, ' at: #DefaultTextStyle) copy
		offset: 0 @ 0'! !

!KillTextConstants methodsFor: 'step3' stamp: 'Bvr 11/26/2010 18:51'!
theClassUsesTextConstants: cl

	| string start end subString |

	string := cl definition.
	start := string findString: 'poolDictionaries'.
	end := string findString: 'category' startingAt: start.
	subString := string copyFrom: start to: end.
	^ subString includesSubString: 'TextConstants'! !

!KillTextConstants methodsFor: 'step6 - fix Paragraph' stamp: 'BenjaminVanRyseghem 11/14/2010 01:04'!
withTextSource
	^'withText: aText 
	"Answer an instance of me with text set to aText and style set to the 
	system''s default text style."

	^self withText: aText style: (', self textConstantsCopySymbol asString, ' at: #DefaultTextStyle) copy'! !
